/*****************************************************************************/
/*                                                                           */
/* FILENAME                                                                  */
/* 	 main.c                                                                  */
/*                                                                           */
/* DESCRIPTION                                                               */
/*   TMS320C5515 USB Stick Application 20 Spectrum Analyser.                 */
/*   Take microphone input and send to headphones with ring modulation.      */
/*                                                                           */
/* REVISION                                                                  */
/*   Revision: 1.00	                                                         */
/*   Author  : Richard Sikora                                                */
/*---------------------------------------------------------------------------*/
/*                                                                           */
/* HISTORY                                                                   */
/*   Revision: 1.00                                                          */
/*   15th September 2010. Created from TMS320C5505 USB Stick code.           */
/*                                                                           */
/*****************************************************************************/
/*
 * Copyright (C) 2010 Texas Instruments Incorporated - http://www.ti.com/ 
 * 
 * 
 *  Redistribution and use in source and binary forms, with or without 
 *  modification, are permitted provided that the following conditions 
 *  are met:
 *
 *    Redistributions of source code must retain the above copyright 
 *    notice, this list of conditions and the following disclaimer.
 *
 *    Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the 
 *    documentation and/or other materials provided with the   
 *    distribution.
 *
 *    Neither the name of Texas Instruments Incorporated nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 *  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
 *  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
 *  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 *  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 *  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
 *  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
*/

#include "stdio.h"
#include "usbstk5515.h"
#include "usbstk5515_led.h"
#include "aic3204.h"
#include "PLL.h"
#include "oled.h"
#include "pushbuttons.h"
#include "stereo.h"
#include "dsplib.h"
#include "sinewaves.h"
#include "math.h"
#include "gsm.h"

//#include "combfilters.h"
#include "IIR.h"

signed int wspLP_lib[6] = {0, 0, 0, 0, 0, 0 };
signed int x2[3] = { 0, 0, 0 };  // próbki wejściowe
signed int y2[3] = { 0, 0, 0 };  // próbki wyjściowe
                                       
signed int x1[3] = { 0, 0, 0 };  // próbki wejściowe
signed int y1[3] = { 0, 0, 0 };  // próbki wyjściowe

signed int wspLP_f[6] = {0, 0, 0, 0, 0, 0 };
signed int xf[3] = { 0, 0, 0 };  // próbki wejściowe
signed int yf[3] = { 0, 0, 0 };  // próbki wyjściowe

Int16 left_input;
Int16 right_input;
Int16 left_output;
Int16 right_output;

#define SAMPLES_PER_SECOND 48000
#define GAIN_IN_dB 0

int fo = 12000;		// częstotliwość VCO
int R = 4000;
double f3dB = 10;	// pasmo filtru sprzężenia zwrotnego

int PSK;
int nosna_cos = 100;
int nosna_sin = 0;
int iloczyn1 = 1000;
int iloczyn2 = 1000;
int out1 = 10;
int out2 = 10;
int out1x2 = 10;
int feedback = 100;
int dem_PSK_bity;

double ALFA,  ALFA_F;
double omega3dB;

const signed int *wspLP;

unsigned int Step = 0; 
unsigned int LastStep = 99;

/* ------------------------------------------------------------------------ *
 *                                                                          *
 *  main( )                                                                 *
 *                                                                          *
 * ------------------------------------------------------------------------ */
void main( void ) 
{
    /* Initialize BSL */
    USBSTK5515_init( );
	
	/* Initialize PLL */
	pll_frequency_setup(120);

    /* Initialise hardware interface and I2C for code */
    aic3204_hardware_init();
    
    /* Initialise the AIC3204 codec */
	aic3204_init(); 
	
	/* Turn off the 4 coloured LEDs */
	USBSTK5515_ULED_init();
	
	/* Initialise the OLED LCD display */
	oled_init();
	SAR_init();
	/* Flush display buffer */
    oled_display_message("                 ", "                   ");
    
    printf("\n\nLaboratorium FCiPS\n");
    printf( "Ćwiczenie 6 Demodulatory z pętlą PLL\n" );
    printf( "Demodulator z pętlą Costasa\n" );

	/* Setup sampling frequency and  gain for microphone */
    set_sampling_frequency_and_gain(SAMPLES_PER_SECOND, GAIN_IN_dB);

    oled_display_message("Laboratorium FCiPS ", "petla pll costasa  ");

	/* New. Add descriptive text */ 
	puts("\n Pętla PLL Costasa");
    printf("Częstotliwość nośna = %5d Hz\n", fo);
    printf("Szybkość transmisji symboli R = %5d Bd\n", R); 
     
	/* Default to XF LED off */
	asm(" bclr XF");
	
    f3dB = 5;			// pasmo filtru sprzężenia zwrotnego
    omega3dB = 2*3.1415926*f3dB/SAMPLES_PER_SECOND;
    ALFA_F = (1.0 - sin(omega3dB))/cos(omega3dB);

    //wsp_LP(2000, SAMPLES_PER_SECOND, wspLP_lib);
    wsp_LP(R >> 1, SAMPLES_PER_SECOND, wspLP_lib);
       
    wsp_LP(5,   SAMPLES_PER_SECOND, wspLP_f); 
        
 	for ( ;; )
 	{
     aic3204_codec_read(&left_input, &right_input); // Configured for one interrupt per two channels.
     PSK = left_input;
	  
     // PLL ----------------------------------------------------------------------------------------- 
     VCO90deltaLongBPSK(fo, feedback, 30000, &nosna_sin, &nosna_cos);
     
     iloczyn1 = _smpyr(PSK, nosna_cos) >> 16;		// detektor fazy 1   
     iloczyn2 = _smpyr(PSK, nosna_sin) >> 16;		// detektor fazy 2     
     
     // Filtry dolnoprzepustowe
     out1  = IIR_I_order(x1, y1, wspLP_lib, iloczyn1);
     out2  = IIR_I_order(x2, y2, wspLP_lib, iloczyn2);
     
	 out1x2 = L_crshft_r((long)out1 * out2, 13);

     //filtr dolnoprzepustowy sprzężenia zwrotnego    
     feedback = LP_VCO_PLL(out1x2, ALFA_F);         
     //feedback  = IIR_I_order(xf, yf, wspLP_f, out1x2) << 2;     
     
     // PLL koniec ----------------------------------------------------------------------------------
	
	 if(out2 > 0) dem_PSK_bity = 20000; else dem_PSK_bity = -20000;    
               
     Step = pushbuttons_read(8);
         
	  if ( Step == 1 )
        {
         if ( Step != LastStep )
          {
           oled_display_message("L = PSK           ", "P = nosna cos     ");
           printf("\n1. Sprawdzenie poziomu sygnałów, regulacja\n");
           printf("Obserwacja sygnału wejściowego i odtworzonej nośnej\n");
           printf("Sygnał wejściowy powinien mieć wartość maksymalną mniejszą od nośnej o kilkanaście procent\n");
           printf("Kanał lewy:  left input   -> out\n");
           printf("Kanał prawy: nośna sinus  -> out\n");
           LastStep = Step;
          }	
         left_output = PSK;      
	     right_output = nosna_cos;
	    } 
	    
	    if ( Step == 2)
        {
         if ( Step != LastStep )
          {
           oled_display_message("L = nosna sin     ", "P = kanal prawy   ");
           printf("\n2. Ocena jakości synchronizacji, obserwacja krzywej Lissajous\n");
           printf("\nPrzy braku synchronizacji wyregulować poziom sygnału wejściowego AM\n");
           printf("Kanał lewy:  nośna sinus -> out\n");
           printf("Kanał prawy: right input -> out\n");
           LastStep = Step;
          }	
         left_output = nosna_sin;     
	     right_output = right_input;	
	    }
	       
	    if ( Step == 3)
        {
         if ( Step != LastStep )
          {
           oled_display_message("L = nosna_sin         ", "P = nosna cos     ");
           printf("\n3. Przy braku synchronizacji wyregulować poziom sygnału wejściowego AM\n");
           printf("Kanał lewy:  nośna sinus -> out\n");
           printf("Kanał prawy: nośna cosinus -> out\n");
           LastStep = Step;
          }	
         left_output = nosna_sin;     
	     right_output = nosna_cos;	
	    } 
	      
	    if ( Step == 4)
        {
         if ( Step != LastStep )
          {
            oled_display_message("L = iloczynin 1   ", "P = iloczynin 2   ");
            printf("\n4. Iloczyny sygnału AM razy nośna synfazowa i kwadraturowa\n");
            printf("Kanał lewy:  AM * cos -> out\n");
            printf("Kanał prawy: AM * sin -> out\n");              
            LastStep = Step;
          }         
         left_output = iloczyn1;
	     right_output = iloczyn2;	
	    }
	    
	    if ( Step == 5)
        {
         if ( Step != LastStep )
          {
            oled_display_message("L = out1          ", "P = out2          "); 
            printf("\n5. Obwiednie sygnału po filtrach dolnoprzepustowych\n");
            printf("Kanał lewy:  obwiednia synfazowa -> out\n");
            printf("Kanał prawy: obwiednia kwadraturowa -> out\n");             
            LastStep = Step;
          }         
         left_output = out1;
	     right_output = out2;	
	    }
	     
	    if ( Step == 6)
        {
         if ( Step != LastStep )
          {
            oled_display_message("L = feedback      ", "P = LP feedback  "); 
             printf("\n6. Sterowanie generatorem VCO\n");
            printf("Kanał lewy:  Sygnał błędu przed filtracją -> out\n");
            printf("Kanał prawy: Sygnał błędu po filtracji -> out\n");            
            LastStep = Step;
          }         
         left_output = out1x2;
	     right_output = feedback;	
	    }
	    
	    if ( Step == 7)
        {
         if ( Step != LastStep )
          {
            oled_display_message("L = out2          ", "P = dem psk bity  ");
            printf("\n7. Obwiednia przed i po progowaniu\n");
            printf("Kanał lewy:  Obwiednia -> out\n");
            printf("Kanał prawy: Obwiednia po progowaniu -> out\n");            
            LastStep = Step;          
            LastStep = Step;
          }         
         left_output = out2;
	     right_output = dem_PSK_bity;	
	    }  
	    
	    if ( Step == 8)
        {
         if ( Step != LastStep )
          {	 
            oled_display_message("patrz na konsole  ", "i wpisz fo dla VCO");
            printf("Podaj częstotliwość VCO fo = ");
    		scanf("%d", &fo); 
    		printf("Podaj liczbę symboli na s (minimum = 1000) [Bd] SR = ");
	    	scanf("%d", &R); 
	    	wsp_LP(R >> 1, SAMPLES_PER_SECOND, wspLP_lib);
	    	oled_display_message("L = PSK           ", "P = nosna cos     ");
           printf("\n1. Sprawdzenie poziomu sygnałów, regulacja\n");
           printf("Obserwacja sygnału wejściowego i odtworzonej nośnej\n");
           printf("Sygnał wejściowy powinien mieć wartość maksymalną mniejszą od nośnej o kilkanaście procent\n");
           printf("Kanał lewy:  left input   -> out\n");
           printf("Kanał prawy: nośna sinus  -> out\n");
	    	    		
            LastStep = Step;
          }         
         left_output = PSK;      
	     right_output = nosna_cos;
	    }  
	    	    
     aic3204_codec_write(left_output, right_output);

 	}

   /* Disable I2S and put codec into reset */ 
    aic3204_disable();

    printf( "\n***Program has Terminated***\n" );
    
    oled_display_message("PROGRAM HAS        ", "TERMINATED        ");
    
    SW_BREAKPOINT;
}

/* ------------------------------------------------------------------------ *
 *                                                                          *
 *  End of main.c                                                           *
 *                                                                          *
 * ------------------------------------------------------------------------ */
